/* 
 * File:   soft_SPI.c
 * Author: chengo_cc
 *
 * Created on 17 December 2015, 11:31 AM
 */

#include <stdio.h>
#include <stdlib.h>
#include <pic.h>
#include "delay.h"
//------------------------------------------------------------------------------
#define SCK     RC0             //Serial Clock
#define SDI     RC1             //Serial Data In
#define SDO     RC2             //Serial Data Out
#define CS      RC3             //Chip Select
//-----------------------PIN directions-----------------------------------------
#define SCK_dir TRISC0
#define SDI_dir TRISC1
#define SDO_dir TRISC2
#define CS_dir  TRISC3
//------------------------------------------------------------------------------
#include "software_SPI.h"
#include "EEPROM.h"
//------------------------------------------------------------------------------
//NB: short is of size 2 Bytes, and char is a byte wide
char  data[] = {0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x98,0x88,0x83,0xC6,0xA1,0x86,0x8E};
/*                 0,   1,   2,   3,   4,   5,   6,   7,   8,   9,   A,   B,   C,   D,   E,   F */
short address[] = {0x0003,0x0031,0x0132,0x0123,0x0004,0x01BF,0x00C6,0x0117,0x01F8,0x0119,0x012A,0x01CB,0x0188,0x012D,0x011E,0x01AF};
/*                 Arbitrarily chosen addresses                                                 */
//------------------------------------------------------------------------------
int main(int argc, char** argv)
{

  SPI_init();

  TRISD = 0;                       //Connect seven segment display to this port.
  PORTD = data[0];                 //7-segment code for 0.

  for(int i = 0; i < 16; i++)
  {
    EEPROM_write(address[i],data[i]);
  }

  while(1)
  {
    for(int i = 0; i < 16; i++)
    {
      PORTD = EEPROM_read(address[i]);
      delay(1000);
    }
  }

  return (EXIT_SUCCESS);
}
//------------------------------------------------------------------------------